try {

    var js = window.js = {};
    var highlighter;
    var searchResultApplier;
    var _currentSeclectedElement;
    var _currentScreenY;
    
    var JY_COLOR_GREEN      = "green";
    var JY_COLOR_BLUE       = "blue";
    var JY_COLOR_ORANGE     = "orange";
    var JY_COLOR_PURPLE     = "purple";
    var JY_COLOR_UNDERLINE  = "underline";
    
    var JY_COLOR_CLASS_GREEN        = "jy_reader_green";
    var JY_COLOR_CLASS_BLUE         = "jy_reader_blue";
    var JY_COLOR_CLASS_ORANGE       = "jy_reader_orange";
    var JY_COLOR_CLASS_PURPLE       = "jy_reader_purple";
    var JY_COLOR_CLASS_UNDERLINE    = "jy_reader_underline";
    
    var JY_COLOR_CLASS_SEARCH       = "jy_search_highlight";
    
    var JY_NOTE_TYPE_HIGHLITE   = "highlight";
    var JY_NOTE_TYPE_NOTE       = "note";
    //    var JY_NOTE_TYPE_IMAGE      = "image";
    //    var JY_NOTE_TYPE_AUDIO      = "audio";


    /** ********************** 初始化 ********************************** */

    $(document).ready(function() { init(); });

    function init() {

        initRangy();

        // 触摸拖动结束的时候出发
        document.addEventListener("touchend", touchEnd, false);

        // 不带缩略图的画廊
        $(".swiper-container").each(function(index) {
            $(this).swiper({
                mode : 'horizontal',
                pagination : ("#" + $(this).attr("id") + "_pagination"),
                paginationClickable : true,
                loop : true
            });
        });

        // 多标签
        $(".jr_tab_container").easyResponsiveTabs({
            type : 'default', // Types: default, vertical, accordion
            width : 'auto', // auto or any custom width
            fit : true, // 100% fits in a container
            activate : function() {
            } // Callback function, gets called if tab is switched
        });

        $("video").each(function(index) {
            if (navigator.userAgent.match(/Android/i)) {
                var src = $(this).attr("src");
                $(this).bind('webkitbeginfullscreen', function(e) {
                    //window.JieYueAndroid.openVideo(src);
                });
            }

        });

        $("video").each(function(index) {
                $(this).bind("playing", videoStarted);
                $(this).bind("pause", videoStoped);
         });
        
        $("audio").each(function(index) {
                $(this).bind("playing", audioStarted);
                $(this).bind("pause", audioStoped);
        });
        
        $("body").css("zoom", js_font_size);
        rePositionNoteIcon();
    }

    var highlighterSetting = {
        ignoreWhiteSpace : true,
        elementTagName : "span",
        elementProperties : {
            onclick : function() {
                _currentSeclectedElement = this;
                var uuid = $(this).attr("uuid");
                var type = $(this).attr("type");
                var color = $(this).attr("color");
                showEditHighlightMenu(uuid, type, color);
                return false;
            }
        }
    };

    var searchHighlighterSetting = {
            ignoreWhiteSpace : true,
            elementTagName : "div",
        };

    function initRangy() {
        rangy.init();
        
        highlighter = rangy.createHighlighter();
        highlighter.addClassApplier(rangy.createCssClassApplier(JY_COLOR_CLASS_BLUE, highlighterSetting));
        highlighter.addClassApplier(rangy.createCssClassApplier(JY_COLOR_CLASS_GREEN, highlighterSetting));
        highlighter.addClassApplier(rangy.createCssClassApplier(JY_COLOR_CLASS_ORANGE, highlighterSetting));
        highlighter.addClassApplier(rangy.createCssClassApplier(JY_COLOR_CLASS_PURPLE, highlighterSetting));
        highlighter.addClassApplier(rangy.createCssClassApplier(JY_COLOR_CLASS_UNDERLINE, highlighterSetting));
        searchResultApplier = rangy.createClassApplier(JY_COLOR_CLASS_SEARCH, searchHighlighterSetting);
    }

    function touchEnd(event) {
        var onClickFunction = $(event.target).attr("onClick");
        if (onClickFunction && onClickFunction != 'undefined'
                && onClickFunction != '') {
            return;
        }

        if (navigator.userAgent.match(/iPhone|iPad|iPod/i)
                && js.contextMenuDidShown) {
            window.location.href = "hideContextMenu://";
            return;
        }
        var touch = event.changedTouches[0] || event.targetTouches[0] || null;
        _currentScreenY = touch.pageY;
        var selection = window.getSelection();
        if (navigator.userAgent.match(/iPhone|iPad|iPod/i) && selection
                && selection.toString() != '') {
            window.location.href = "showContextMenu://";
        }
    }

    /**
     * ********************************* 控件事件相关 ******************************************
     */

     //后面这几个都是统计要用的
    function videoStarted(event) {//注意一个页面内可能同时打开多个视频，音频
        var fullPath = $(event.target).attr("src");
        if (fullPath === undefined) {
            return;
        }
        
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.videoStarted(fullPath);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://videoStarted?fullPath=" + encodeURIComponent(fullPath);
            event.stopPropagation();
        } else {// pc
            
        }
    }
    
    function videoStoped(event) {
        var fullPath = $(event.target).attr("src");
        if (fullPath === undefined) {
            return;
        }
        
        var name = $(event.target).attr("name");
        if (name === undefined) {
            name="";
        }
        
        var desc = $(event.target).attr("desc");
        if (desc === undefined) {
            desc="";
        }
        
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.videoStoped(fullPath, name, desc);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://videoStoped?fullPath=" + encodeURIComponent(fullPath);
            event.stopPropagation();
        } else {// pc
            
        }
    }
    
    function audioStarted(event) {//注意一个页面内可能同时打开多个视频，音频
        var fullPath = $(event.target).attr("src");
        if (fullPath === undefined) {
            return;
        }
        
        var name = $(event.target).attr("name");
        if (name === undefined) {
            name="";
        }
        
        var desc = $(event.target).attr("desc");
        if (desc === undefined) {
            desc="";
        }
        
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.audioStarted(fullPath, name, desc);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://audioStarted?fullPath=" + encodeURIComponent(fullPath);
            event.stopPropagation();
        } else {// pc
            
        }
    }
    
    function audioStoped(event) {
        var fullPath = $(event.target).attr("src");
        if (fullPath === undefined) {
            return;
        }
        
        var name = $(event.target).attr("name");
        if (name === undefined) {
            name = "";
        }
        
        var desc = $(event.target).attr("desc");
        if (desc === undefined) {
            desc = "";
        }
        
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.audioStoped(fullPath, name, desc);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://audioStoped?fullPath=" + encodeURIComponent(fullPath);
            event.stopPropagation();
        } else {// pc
            
        }
    }

    function openLink(event, linktType, linkSource, name, desc, showPlayer) {
        var isShow = (showPlayer === undefined || showPlayer === null) ? 0 : showPlayer;
        var aName = (name === undefined || name === null) ? '' : name;
        var aDesc = (desc === undefined || desc === null) ? '' : desc;

        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.openLink(linktType, linkSource, isShow, encodeURIComponent(aName), encodeURIComponent(aDesc));
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "openLink://linktType="
                    + encodeURIComponent(linktType) + "&linkSource="
                    + encodeURIComponent(linkSource) + "&showPlayer=" + isShow
                    + "&name=" + encodeURIComponent(aName) + "&desc=" + aDesc;
            event.stopPropagation();
        } else {// pc

        }
    }

    function show3DModel(event) {
        var modeFilePath = $(event.target).attr("AR-file");
        var modeName = $(event.target).attr("name");
        var targetImage = $(event.target).attr("src");
        if (modeFilePath === undefined) {
            return;
        }
        
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.show3DModel(modeFilePath, modeName, targetImage);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "show3DModel://modeFilePath="
                    + encodeURIComponent(modeFilePath) + "&modeName="
                    + encodeURIComponent(modeName);
            event.stopPropagation();
        } else {// pc

        }
    }

    function showH5Model(event, path, name) {
        if (path === undefined) {
            return;
        }

        window.JieYueAndroid.openH5Model(path, name);
    }

    function showHotImage(event) {
        var xmlPath = $(event.target).attr("file");
        if (xmlPath === undefined) {
            return;
        }
        
        var name = $(event.target).attr("name");
        var desc = $(event.target).attr("desc");
        name = (name === undefined || name === null) ? '' : name;
        desc = (desc === undefined || desc === null) ? '' : desc;
        
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.showHotImage(xmlPath, name, desc);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://showHotImage?xmlPath=" + encodeURIComponent(xmlPath)
            event.stopPropagation();
        } else {// pc

        }
    }

    function showBigImage(event) {
        var name = $(event.target).attr("name");
        var desc = $(event.target).attr("desc");

        name = (name === undefined || name === null) ? '' : name;
        desc = (desc === undefined || desc === null) ? '' : desc;

        var imagePath = $(event.target).attr("path");
        if (imagePath === undefined) {
            return;
        }
        
        
        if (imagePath === undefined || imagePath === null) {
            imagePath = $(event.target).attr("src");
        }

        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.ShowBigImage(imagePath,name,desc);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://showBigImage?imagePath=" + encodeURIComponent(imagePath)
                                                    + "&name=" + encodeURIComponent(name) 
                                                    + "&desc=" + encodeURIComponent(desc);

            event.stopPropagation();

        } else {// pc

        }
    }

    function showGroupPhotos(event) {
        var xmlPath = $(event.target).attr("imagesXML");

          if (xmlPath === undefined) {
             return;
          }
        
        var name = $(event.target).attr("name");
        var desc = $(event.target).attr("desc");
        var type = $(event.target).attr("type");
        
        name = (name === undefined || name === null) ? '' : name;
        desc = (desc === undefined || desc === null) ? '' : desc;
        type = (type === undefined || type === null) ? '' : type;
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.ShowGroupImage(xmlPath, name, desc, type);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
                 window.location.href = "jycommand://showGroupPhotos?xmlPath=" + encodeURIComponent(xmlPath);

            event.stopPropagation();

        } else {// pc

        }
    }

    function showImageSlider(event) {
        var xmlPath = $(event.target).attr("imagesXML");
        
        if (xmlPath === undefined) {
            return;
        }
        
        var name = $(event.target).attr("name");
        var desc = $(event.target).attr("desc");
        name = (name === undefined || name === null) ? '' : name;
        desc = (desc === undefined || desc === null) ? '' : desc;
        
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.showImageSlider(xmlPath, name, desc);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://showImageSlider?xmlPath=" + encodeURIComponent(xmlPath);
            
            event.stopPropagation();
            
        } else {// pc
            
        }
    }

    function showPPT(event, pptPath, title) {
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.showPPT(pptPath, title);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://showPPT?pptPath="
                    + encodeURIComponent(pptPath) + "&title="
                    + encodeURIComponent(title);
            event.stopPropagation();
        } else {// pc

        }
    }

    function showDOC(event, docPath, title) {
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.showDOC(docPath, title);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://showDOC?docPath="
                    + encodeURIComponent(docPath) + "&title="
                    + encodeURIComponent(title);
            event.stopPropagation();
        } else {// pc

        }
    }

    function showXSL(event, xslPath, title) {
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.showExcel(xslPath, title);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://showExcel?xslPath="
                    + encodeURIComponent(xslPath) + "&title="
                    + encodeURIComponent(title);
            event.stopPropagation();
        } else {// pc

        }
    }

    function showPDF(event, pdfPath, title) {
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.showPDF(pdfPath, title);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://showPDF?pdfPath="
            + encodeURIComponent(pdfPath) + "&title="
            + encodeURIComponent(title);
            event.stopPropagation();
        } else {// pc
            
        }
    }

    function showHomework(event, questionsPath, title, isexam, name, desc, location) {
        if (navigator.userAgent.match(/Android/i)) { // android
            //alert(isexam);
            window.JieYueAndroid.showHomework(questionsPath, title, isexam, name, desc, location);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://showHomework?questionsPath="
                    + encodeURIComponent(questionsPath) + "&title="
                    + encodeURIComponent(title) + "&isexam=" + isexam;
            event.stopPropagation();
        } else {// pc

        }
    }

    function openArticle(event, path) {
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.openArticle(path);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://openArticle?path=" + encodeURIComponent(path);
            event.stopPropagation();
        } else {// pc
           
        }
    }

    //替换showNoteToUpdate，用来显示已有高亮或笔记时候的弹窗
    function showEditHighlightMenu(uuid, type, color) {
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.showEditHighlightMenu(uuid, type, color);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://showEditHighlightMenu?uuid=" + encodeURIComponent(uuid) +
                                                                     "&type=" + encodeURIComponent(type) +
                                                                     "&color=" + encodeURIComponent(color);
            event.stopPropagation();
        } else {// pc
            
        }
    }

    function showNoteToUpdate(event, uuid) {
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.showNoteToUpdate(uuid);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://showNoteToUpdate?uuid="
                + encodeURIComponent(uuid);
            event.stopPropagation();
        } else {// pc

        }
    }

    /** ******************************************************************* */

    /*
     * clear selection
     */
    function clearCurrentSelection() {
        if (window.getSelection) {
             if (window.getSelection().removeAllRanges) {  // Firefox
                window.getSelection().removeAllRanges();
             } else if (window.getSelection().empty) {  // Chrome
                 window.getSelection().empty();
            }
    } else if (document.selection) { // IE?
            document.selection.empty();
        }
    }

    /*
     * note current selection
     * 高亮接口
     */
    function highlight(uuid, type, color) {
        var colorType = (color === undefined || color === null) ? JY_COLOR_GREEN : color;
        //var selObj = rangy.getSelection();
        //var serializeSelection = rangy.serializeSelection(selObj, true);
        createNewHighlight(uuid, type, colorType);
        //alert("getRange=" + android.selection.getRange() + '\r\n' + "android.serializeSelection=" + android.serializeSelection);
 
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.setSerializeSelection(uuid,android.serializeSelection);
        }
        //return serializeSelection;
    }
    
     /*
     * 获取选中的文字
     */
    function getSelectionText(event) {
        if (navigator.userAgent.match(/Android/i)) { // android
            window.getSelectAndroid.getSelectText(event, window.getSelection().toString(), android.selection.getRange());
        }
    }
    
    /*
     * note current selection
     * 高亮接口
     */
    function highlightAfterM(uuid, type, color) {
        var colorType = (color === undefined || color === null) ? JY_COLOR_GREEN : color;
        createNewHighlight(uuid, type, colorType);
    }
    

    /*
     * create new hightlight color
     * 不用管
     */
    function createNewHighlight(uuid, type, color) {
        if (color === JY_COLOR_GREEN) {
            highlighter.highlightSelection(JY_COLOR_CLASS_GREEN);
        } else if (color === JY_COLOR_BLUE) {
            highlighter.highlightSelection(JY_COLOR_CLASS_BLUE);
        } else if (color === JY_COLOR_ORANGE) {
            highlighter.highlightSelection(JY_COLOR_CLASS_ORANGE);
        } else if (color === JY_COLOR_PURPLE) {
            highlighter.highlightSelection(JY_COLOR_CLASS_PURPLE);
        } else if (color === JY_COLOR_UNDERLINE) {
            highlighter.highlightSelection(JY_COLOR_CLASS_UNDERLINE);
        }
    
        var length = highlighter.highlights.length;
        if (length > 0) {
            var highlight = highlighter.highlights[length - 1];
            var eleArray = highlight.getHighlightElements();
            for (var i = 0; i < eleArray.length; i++) {
                var el = eleArray[i];
                if (i == (eleArray.length - 1) && type == JY_NOTE_TYPE_NOTE) {
                    //$(el).addClass("jy_note_sub_icon_cls");
                    addNoteIcon(uuid, el);
                }
                _currentSeclectedElement = el;
                if (uuid != undefined && uuid != null) {
                    $(el).attr("uuid", uuid);
                }
                if (type != undefined && type != null) {
                    $(el).attr("type", type);
                }
                if (color != undefined && color != null) {
                    $(el).attr("color", color);
                }
            }
        }
    }

    /*
     * update current Highlight
     * 用于换颜色，把高亮变笔记用
     */
    function updateCurrentHighlight(uuid, type, color) {
        var elColor = $(_currentSeclectedElement).attr("color");
        color = (color === undefined || color === null) ? elColor : color;
        
        var targetClassApplier;
        if (color === JY_COLOR_GREEN) {
            targetClassApplier = highlighter.classAppliers[JY_COLOR_CLASS_GREEN];
        } else if (color === JY_COLOR_BLUE) {
            targetClassApplier = highlighter.classAppliers[JY_COLOR_CLASS_BLUE];
        } else if (color === JY_COLOR_ORANGE) {
            targetClassApplier = highlighter.classAppliers[JY_COLOR_CLASS_ORANGE];
        } else if (color === JY_COLOR_PURPLE) {
            targetClassApplier = highlighter.classAppliers[JY_COLOR_CLASS_PURPLE];
        } else if (color === JY_COLOR_UNDERLINE) {
            targetClassApplier = highlighter.classAppliers[JY_COLOR_CLASS_UNDERLINE];
        }
        
        var highlight = highlighter.getHighlightForElement(_currentSeclectedElement);
        if (highlight != undefined && highlight != null) {
            highlight.unapply();
            highlight.classApplier = targetClassApplier;
            highlight.apply();
            
            var eleArray = highlight.getHighlightElements();
            for (var i = 0; i < eleArray.length; i++) {
                var el = eleArray[i];
                if (i == (eleArray.length - 1) && type == JY_NOTE_TYPE_NOTE) {
                    //$(el).addClass("jy_note_sub_icon_cls");
                    addNoteIcon(uuid, el);
                }
                
                if (uuid != undefined && uuid != null) {
                    $(el).attr("uuid", uuid);
                }
                if (type != undefined && type != null) {
                    $(el).attr("type", type);
                }
                if (color != undefined && color != null) {
                    $(el).attr("color", color);
                }
            }
        }
    }

    /*
     * remove current select highlight
     * 删除某个笔记的时候用
     */
    function removeCurrentSelectedHighlight() {
        var highlight = highlighter.getHighlightForElement(_currentSeclectedElement);
        var eleArray = highlight.getHighlightElements();
        for (var i = 0; i < eleArray.length; i++) {
            var el = eleArray[i];
            //$(el).removeClass("jy_note_sub_icon_cls");
            var uuid = $(el).attr("uuid");
            $("div[uuid='" + uuid + "']").remove();
            $(el).removeAttr("uuid");
            $(el).removeAttr("type");
            $(el).removeAttr("color");
            $(el).removeAttr("onClick");
        }
        //highlighter.unhighlightSelection();
        highlighter.removeHighlights([highlight]);
    }

    /**
     * restore Notes
     * 在加载完webview数据后还原本页笔记
     */
    function restoreNotes(uuid, type, color, serializeSelection) {
        var colorType = (color === undefined || color === null) ? JY_COLOR_GREEN : color;
        rangy.deserializeSelection(serializeSelection);
        createNewHighlight(uuid, type, colorType);
        
        if (navigator.userAgent.match(/Android/i)) { // android
            android.selection.clearSelection();
        }
        
        clearCurrentSelection();
    }

    //共享笔记用，点击某人笔记，先removeAllHighlightsOnThisPage，然后调restoreNotes还原某人笔记
    function removeAllHighlightsOnThisPage() {
        for (var i = 0; i < highlighter.highlights.length; i++) {
            var highlight = highlighter.highlights[i];
            var eleArray = highlight.getHighlightElements();
            for (var j = 0; j < eleArray.length; j++) {
                var el = eleArray[j];
                //$(el).removeClass("jy_note_sub_icon_cls");
                var uuid = $(el).attr("uuid");
                $("div[uuid='" + uuid + "']").remove();
                
                $(el).removeAttr("uuid");
                $(el).removeAttr("type");
                $(el).removeAttr("color");
                $(el).removeAttr("onClick");
            }
        }
        highlighter.removeAllHighlights();
    }

    function removeAllCurrentSearchHighlight() {
        var searchRange = rangy.createRange();
        searchRange.selectNodeContents(document.body);
        searchResultApplier.undoToRange(searchRange);
    }

//    function scrollToBottom() {
//        var height = $(document).height();
//        window.scroll(0, height);
//    }
    
    function scrollToHighlightByUUID(uuid) {
        var noteLoationElement = $("span[uuid='" + uuid + "']:first")[0];
        if  (noteLoationElement && noteLoationElement != "undefined") {
            var offsetVal = $(noteLoationElement).offset();
            window.scroll(0, offsetVal.top-60);
        }
    }
    
    function doSearch(searchString) {
        if (searchString !== "") {
            var searchRange = rangy.createRange();
            searchRange.selectNodeContents(document.body);
            searchResultApplier.undoToRange(searchRange);
            
            var searchScopeRange = rangy.createRange();
            searchScopeRange.selectNodeContents(document.body);
            var options = {
                caseSensitive: false,
                wholeWordsOnly: false,
                withinRange: searchScopeRange,
                direction: "forward"
            };
        
            while (searchRange.findText(searchString, options)) {
                searchResultApplier.applyToRange(searchRange);
                searchRange.collapse(false);
            }
        }
    }

    /*
     * add note icon for current selection at an Y position
     */
    function addNoteIcon(uuid, noteObj) {
        if    (noteObj && noteObj != "undefined") {
            var el = $('<i/>').css('display','inline').insertAfter(noteObj);
            var pos = el.offset();//el[0].getBoundingClientRect();
            el.remove();
            
            var noteImage = document.createElement("div");
            noteImage.className = "jy_note_icon_cls";
            noteImage.style.left = pos.left - 10;
            noteImage.style.top = pos.top + 10;
            
            
            $(noteImage).attr("uuid", uuid);
            $(noteImage).attr("onClick", "showNoteToUpdate(event, '" + uuid + "')");
            $(noteImage).appendTo("#cf_book_content_div");
        }
    }
    
    function rePositionNoteIcon() {
        for (var i = 0; i < highlighter.highlights.length; i++) {
            var highlight = highlighter.highlights[i];
            var eleArray = highlight.getHighlightElements();
            for (var j = 0; j < eleArray.length; j++) {
                var el = eleArray[j];
                var uuid = $(el).attr("uuid");
                var type = $(el).attr("type");
                
                if (j == (eleArray.length - 1) && type == JY_NOTE_TYPE_NOTE) {
                    var tempEL = $('<i/>').css('display','inline').insertAfter(el);
                    var pos = tempEL.offset();
                    tempEL.remove();
                    $("div[uuid='" + uuid + "']:first").offset({left:pos.left - 10, top:pos.top + 10});
                }
            }
        }
    }

    function setFontSizeClass(fontSize) {
        var size = '100%';
        if (fontSize == 1) {
            size = '85%';
        } else if (fontSize == 2) {
            size = '90%';
        } else if (fontSize == 3) {
            size = '95%';
        } else if (fontSize == 4) {
            size = '100%';
        } else if (fontSize == 5) {
            size = '105%';
        } else if (fontSize == 6) {
            size = '110%';
        } else if (fontSize == 7) {
            size = '115%';
        }
        //document.getElementsByTagName('body')[0].style.webkitTextSizeAdjust = size;
        
        $("body").css("zoom", size);
        rePositionNoteIcon();
    }

    function setBase64Img(imgId, base64Str) {
        var img = document.getElementById(imgId);
        img.src = base64Str;
    }

    function pauseAllVideo() {
        var videos = document.querySelectorAll("video");
        for ( var i = videos.length - 1; i >= 0; i--) {
            videos[i].pause();
        }
    }

    function pauseAllAudio() {
            var audios = document.querySelectorAll("audio");
            for ( var i = audios.length - 1; i >= 0; i--) {
                if (!audios[i].paused) {
                    audios[i].pause();
                }
            }
        }
    
    function pauseVideoWithoutPath(path) {
        var videos = document.querySelectorAll("video");
        for ( var i = videos.length - 1; i >= 0; i--) {
            var src = $(videos[i]).attr("src");
            if ((src != undefined && src != null) && src.indexOf(path) == -1) {
                videos[i].pause();
            }
        }
    }
    
    function downloadVideo(event) {
        var videoPath = $(event.target).attr("videoPath");
        var bookId = $(event.target).attr("bookId");
        doDownloadVideo(videoPath, bookId, false);
        $(event.target).text("下载中");
        $(event.target).attr("disabled","disabled");


    }

    function downloadModel(event) {
            var modelPath = $(event.target).attr("modelPath");
            var bookId = $(event.target).attr("bookId");
            doDownloadModel(modelPath, bookId, false);
            $(event.target).text("下载中");
            $(event.target).attr("disabled","disabled");
        }
    
    function doDownloadVideo(videoPath, bookId, showConfirm) {
        if (videoPath === undefined || bookId === undefined) {
            return;
        }
        
        if (navigator.userAgent.match(/Android/i)) {
            window.JieYueAndroid.doDownloadVideo(encodeURIComponent(videoPath), bookId, showConfirm);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://downloadVideo?videoPath=" + encodeURIComponent(videoPath)
            + "&bookId=" + bookId + "&showConfirm=" + showConfirm;
            
            event.stopPropagation();
        } else {// pc
            
        }
    }

    function doDownloadModel(modelPath, bookId, showConfirm) {
            if (modelPath === undefined || bookId === undefined) {
                return;
            }

            if (navigator.userAgent.match(/Android/i)) {
                window.JieYueAndroid.doDownloadModel(encodeURIComponent(modelPath), bookId, showConfirm);
                event.stopPropagation();
            } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
                window.location.href = "jycommand://downloadVideo?videoPath=" + encodeURIComponent(videoPath)
                + "&bookId=" + bookId + "&showConfirm=" + showConfirm;

                event.stopPropagation();
            } else {// pc

            }
        }
    
    function openVideo(event, videoPath) {
        if (videoPath === undefined) {
            return;
        }
        var name = $(event.target).attr("name");
        var desc = $(event.target).attr("desc");
        
        name = (name === undefined || name === null) ? '' : name;
        desc = (desc === undefined || desc === null) ? '' : desc;
        
        if (navigator.userAgent.match(/Android/i)) {
            window.JieYueAndroid.openVideo(videoPath,name,desc);
            event.stopPropagation();
        }
    }
    
    function showEncVideo(event, videoPath) {
        if (videoPath === undefined) {
            return;
        }
        
        var name = $(event.target).attr("name");
        name = (name === undefined || name === null) ? '' : name;
        
        window.JieYueAndroid.openOnlineVideo(videoPath, name);
        event.stopPropagation();
    }
    
     function showEncVideoOnline(event, videoPath, mEisbn) {
        if (videoPath === undefined) {
            return;
        }
        
        var name = $(event.target).attr("name");
        name = (name === undefined || name === null) ? '' : name;
        
        window.JieYueAndroid.openOnlineVideoEisbn(videoPath, name ,mEisbn);
        event.stopPropagation();
    }

    function showEncModelOnline(event, modeloPath, mEisbn) {
            if (modeloPath === undefined) {
                return;
            }

            var name = $(event.target).attr("name");
            name = (name === undefined || name === null) ? '' : name;

            window.JieYueAndroid.openOnlineModelEisbn(modeloPath, name ,mEisbn);
            event.stopPropagation();
        }
    

    function isCurrentPageContainsVideo(videoId, videoPath, state,mEisbn) {
        window.JieYueAndroid.isVideoExist($("div[id='" + videoId + "']").length > 0, videoId, videoPath, state);
    }
    
    function reloadVideoById(videoDivId, videoPath, bookId, state,mEisbn,isResource) {
      
        if (state === 'undownload') {
            if ( $("div[id='" + videoDivId + "'] button").length > 0) {
                $("div[id='" + videoDivId + "'] button").remove();
            }
            if(isResource==='1'){
               $("div[id='" + videoDivId + "'] > div.jr_component_title_div")
               .prepend("<button style='float:right;margin-top:12px '  type='button' videoPath='" + videoPath + "' bookId = '" + bookId +  "' onClick=\"showEncVideoOnline(event, '" + videoPath +"','" + mEisbn +"');\">在线看</button>")
               .prepend("<button style='float:right;margin-top:12px;margin-left:5px' type='button' videoPath='" + videoPath + "' bookId = '" + bookId +  "' onClick='downloadVideo(event);'>下载</button>");
            }else{
               $("div[id='" + videoDivId + "'] > div.jr_component_title_div")
               .prepend("<button style='float:right;margin-top:12px;margin-left:5px' type='button' videoPath='" + videoPath + "' bookId = '" + bookId +  "' onClick='downloadVideo(event);'>下载</button>");
            }
            $("div[id='" + videoDivId + "'] video")[0].load();
            
        } else if (state === 'downloading') {
            if ( $("div[id='" + videoDivId + "'] button").length > 0) {
                $("div[id='" + videoDivId + "'] button").remove();
            }
             if(isResource==='1'){
                $("div[id='" + videoDivId + "'] > div.jr_component_title_div")
                .prepend("<button style='float:right;margin-top:12px '  type='button' videoPath='" + videoPath + "' bookId = '" + bookId +  "' onClick=\"showEncVideoOnline(event, '" + videoPath +"','" + mEisbn +"');\">在线看</button>")
                .prepend("<button style='float:right;margin-top:12px;margin-left:5px' type='button' disabled＝'disabled'>下载中</button>");
             }else{
               $("div[id='" + videoDivId + "'] > div.jr_component_title_div")
               .prepend("<button style='float:right;margin-top:12px;margin-left:5px' type='button' disabled＝'disabled'>下载中</button>");
             }
            
        }  else if (state === 'finished') {
            //$("#" + videoDivId + " input").remove();
            //videoDivId包含特殊字符，所以不能用上面这种形式
            $("div[id='" + videoDivId + "'] button").remove();
            $("div[id='" + videoDivId + "'] > div.jr_component_title_div").prepend("<button style='float:right;margin-top:12px;margin-left:5px' type='button' videoPath='" + videoPath + "' bookId = '" + bookId + "' onClick=\"openVideo(event, '" + videoPath +"');\" >全屏</button>");
            $("div[id='" + videoDivId + "'] video")[0].load();
        }
    }


    function reloadModelById(modelDivId, modelPath, bookId, state, mEisbn, isResource, isAr) {

            if (state === 'undownload') {
                if ( $("div[id='" + modelDivId + "'] button").length > 0) {
                    $("div[id='" + modelDivId + "'] button").remove();
                }
                if(isResource==='1' && isAr === '0'){
                   $("div[id='" + modelDivId + "'] > div.jr_component_title_div")
                   .prepend("<button style='float:right;margin-top:12px '  type='button' modelPath='" + modelPath + "' bookId = '" + bookId +  "' onClick=\"showEncModelOnline(event, '" + modelPath +"','" + mEisbn +"');\">在线看</button>")
                   .prepend("<button style='float:right;margin-top:12px;margin-left:5px' type='button' modelPath='" + modelPath + "' bookId = '" + bookId +  "' onClick='downloadModel(event);'>下载</button>");
                }else{
                   $("div[id='" + modelDivId + "'] > div.jr_component_title_div")
                   .prepend("<button style='float:right;margin-top:12px;margin-left:5px' type='button' modelPath='" + modelPath + "' bookId = '" + bookId +  "' onClick='downloadModel(event);'>下载</button>");
                }

            } else if (state === 'downloading') {
                if ( $("div[id='" + modelDivId + "'] button").length > 0) {
                    $("div[id='" + modelDivId + "'] button").remove();
                }
                 if(isResource==='1'  && isAr === '0'){
                    $("div[id='" + modelDivId + "'] > div.jr_component_title_div")
                    .prepend("<button style='float:right;margin-top:12px '  type='button' modelPath='" + modelPath + "' bookId = '" + bookId +  "' onClick=\"showEncModelOnline(event, '" + modelPath +"','" + mEisbn +"');\">在线看</button>")
                    .prepend("<button style='float:right;margin-top:12px;margin-left:5px' type='button' disabled＝'disabled'>下载中</button>");
                 }else{
                   $("div[id='" + modelDivId + "'] > div.jr_component_title_div")
                   .prepend("<button style='float:right;margin-top:12px;margin-left:5px' type='button' disabled＝'disabled'>下载中</button>");
                 }

            }  else if (state === 'finished') {
                $("div[id='" + modelDivId + "'] button").remove();
                //videoDivId包含特殊字符，所以不能用上面这种形式
//                $("div[id='" + videoDivId + "'] > div.jr_component_title_div > p").append("<button style='float:right;margin-top:12px;margin-left:5px' type='button' videoPath='" + videoPath + "' bookId = '" + bookId + "' onClick=\"openVideo(event, '" + videoPath +"');\" >全屏</button>");
            }
        }
    
    function scrollToWidgetByQRCodeId(qrcodeId) {
        var qrElement = $("*[qrcode-id='" + qrcodeId + "']:first")[0];
        if (qrElement && qrElement != "undefined") {
            var offsetVal = $(qrElement).offset();
            window.scroll(0, offsetVal.top);
        }
    }
    
    function showGroupWidget(event, groupPath, title) {
            window.JieYueAndroid.showGroupWeight(groupPath, title);
            event.stopPropagation();
    }
    
    function showHTML(event, htmlPath, title) {
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.showHTML(htmlPath, title);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://showHTML?htmlPath="
            + encodeURIComponent(htmlPath) + "&title="
            + encodeURIComponent(title);
            event.stopPropagation();
        } else {// pc
            
        }
    }

    function loadHash(hashName) {
        window.location.hash = hashName;
    }

    function scrollToTop() {
        document.body.scrollTop = document.documentElement.scrollTop = 0;
    }

} catch (error) {
    alert("JS error: " + error);
}